package de.avat.tools.tags;

import org.jetbrains.annotations.NotNull;

import java.lang.ref.WeakReference;
import java.util.Map;
import java.util.WeakHashMap;

/**
 * The default implementation holds the tags in memory
 */
public class DefaultTagManager<T> extends MemoryTagManager<T> {
  public DefaultTagManager() {
    setTaggableFactory( new TaggableFactory<T>() {
      @NotNull
      public Taggable createTaggable( @NotNull T o ) {
        TagSet<T> taggable = new TagSet<T>( o );
        store.put( o, new WeakReference<Taggable>( taggable ) );
        return taggable;
      }
    } );
  }

  public void commit( @NotNull Taggable taggable ) {
    //do nothing - we have no database
  }
}
