package de.avat.tools.tags.ui;

import de.avat.tools.tags.Tag;
import de.avat.tools.tags.TagObservable;
import de.avat.tools.tags.Taggable;
import org.jetbrains.annotations.NotNull;

/**
 * Dummy implementation
 */
public class DefaultTagsComponentModel implements TagsComponentModel {
  private final Taggable selectedTags;
  private final TagObservable availableTags;

  public DefaultTagsComponentModel( @NotNull TagObservable availableTags, @NotNull Taggable selectedTags ) {
    this.selectedTags = selectedTags;
    this.availableTags = availableTags;
  }

  public void selectTag( @NotNull Tag tag ) {
    selectedTags.addTag( tag );
  }

  @NotNull
  public TagObservable getAvailableTags() {
    return availableTags;
  }

  @NotNull
  public Taggable getSelectedTags() {
    return selectedTags;
  }

  public void unselectTag( @NotNull Tag tag ) {
    if ( !selectedTags.removeTag( tag ) ) {
      throw new IllegalStateException( "Could not remove tag: " + tag );
    }
  }
}
