/*
 * Created by JFormDesigner on Tue Apr 03 13:02:00 CEST 2007
 */

package de.avat.tools.tags.ui;

import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.FormSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.layout.Sizes;
import de.avat.tools.tags.DefaultTagManager;
import de.avat.tools.tags.Tag;
import de.avat.tools.tags.MemoryTagManager;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 */
public class TagsComponent extends JPanel {
  private TagsComponentModel model;

  public TagsComponent() {
    this( null );
  }

  public TagsComponent( @Nullable TagsComponentModel model ) {
    initComponents();

    //Set the model
    if ( model != null ) {
      setModel( model );
    } else {
      MemoryTagManager<Object> tagManager = new DefaultTagManager<Object>();
      setModel( new DefaultTagsComponentModel( tagManager, tagManager.getTaggable( this ) ) );
    }

    //Initialize the combo box
    tagCombo.setRenderer( new TagListCellRenderer() );

    //The list with the selected tags

    tagList.setCellRenderer( new TagListCellRenderer() );

    //The Button Actions
    ActionListener addListener = new ActionListener() {
      public void actionPerformed( ActionEvent e ) {
        Tag tag = ( Tag ) tagCombo.getSelectedItem();
        if ( tag != null ) {
          TagsComponent.this.model.selectTag( tag );
        }
      }
    };
    addButton.addActionListener( addListener );

    removeButton.addActionListener( new ActionListener() {
      public void actionPerformed( ActionEvent e ) {
        Object[] selected = tagList.getSelectedValues();
        if ( selected == null ) {
          return;
        }

        for ( Object o : selected ) {
          TagsComponent.this.model.unselectTag( ( Tag ) o );
          TagsComponent.this.model.getSelectedTags().removeTag( ( Tag ) o );
        }
      }
    } );
  }

  public void setAllowNewTagCreation( boolean allowNewTagCreation ) {
    tagCombo.setEditable( allowNewTagCreation );
  }

  public boolean isAllowNewTagCreation() {
    return tagCombo.isEditable();
  }

  protected void updateRemoveButtonState() {
    removeButton.setEnabled( tagList.getSelectedIndices().length > 0 );
  }

  @NotNull
  public TagsComponentModel getModel() {
    return model;
  }

  @NotNull
  public JComboBox getTagCombo() {
    return tagCombo;
  }

  @NotNull
  public JList getTagList() {
    return tagList;
  }

  public void setModel( @NotNull TagsComponentModel model ) {
    this.model = model;
    tagCombo.setModel( new TagComboBoxModel( getModel().getAvailableTags(), false ) );
    TagListModel tagListModel = new TagListModel( getModel().getSelectedTags(), false );
    tagList.setModel( tagListModel );

    tagList.setSelectionModel( new TagListSelectionMode( tagListModel ) );
    tagList.getSelectionModel().addListSelectionListener( new ListSelectionListener() {
      public void valueChanged( ListSelectionEvent e ) {
        if ( e.getValueIsAdjusting() ) {
          return;
        }
        updateRemoveButtonState();
      }
    } );
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
    tagCombo = new JComboBox();
    addButton = new JButton();
    scrollPane1 = new JScrollPane();
    tagList = new JList();
    panel1 = new JPanel();
    removeButton = new JButton();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setLayout( new FormLayout(
        new ColumnSpec[]{
            new ColumnSpec( ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW ),
            FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
            FormFactory.BUTTON_COLSPEC
        },
        new RowSpec[]{
            new RowSpec( RowSpec.FILL, Sizes.DEFAULT, FormSpec.NO_GROW ),
            FormFactory.LINE_GAP_ROWSPEC,
            new RowSpec( RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW )
        } ) );

    //---- tagCombo ----
    tagCombo.setEditable( true );
    add( tagCombo, cc.xy( 1, 1 ) );

    //---- addButton ----
    addButton.setText( "Add" );
    add( addButton, cc.xy( 3, 1 ) );

    //======== scrollPane1 ========
    {
      scrollPane1.setViewportView( tagList );
    }
    add( scrollPane1, cc.xy( 1, 3 ) );

    //======== panel1 ========
    {
      panel1.setLayout( new FormLayout(
          new ColumnSpec[]{
              FormFactory.BUTTON_COLSPEC
          },
          RowSpec.decodeSpecs( "top:default:grow" ) ) );

      //---- removeButton ----
      removeButton.setText( "Remove" );
      removeButton.setEnabled( false );
      panel1.add( removeButton, cc.xy( 1, 1 ) );
    }
    add( panel1, cc.xy( 3, 3 ) );
    // JFormDesigner - End of component initialization  //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
  JComboBox tagCombo;
  private JButton addButton;
  private JScrollPane scrollPane1;
  private JList tagList;
  private JPanel panel1;
  private JButton removeButton;
  // JFormDesigner - End of variables declaration  //GEN-END:variables

}
