package de.avat.tools.tags.ui;

import de.avat.tools.tags.Tag;
import de.avat.tools.tags.TagObservable;
import de.avat.tools.tags.Taggable;
import org.jetbrains.annotations.NotNull;

/**
 * The model for a {@link TagsComponent}.
 * Only the selected tags are observable!
 */
public interface TagsComponentModel {
  /**
   * Select the givne tag
   *
   * @param tag the tag that is selected
   */
  void selectTag( @NotNull Tag tag );

  /**
   * unselect the tag
   *
   * @param tag the tag that is unselected
   */
  void unselectTag( @NotNull Tag tag );

  @NotNull
  Taggable getSelectedTags();

  @NotNull
  TagObservable getAvailableTags();
}
